Hier findest du einige Hinweise zum Arbeiten mit der Command Line (Windows) bzw. dem Terminal (Mac / Linux). Die beiden Begriffe werden hier austauchbar verwendet, da bis auf einige Ausnahmen die Befehle und der Umgang gleich sind.

# Terminal öffnen

**Mac**: Spotlightsuche mit ``cmd`` + ``Leertaste`` öffnen, "Terminal" suchen und mit Doppelklick öffnen

**Windows**: Windows-Taste drücken, nach "cmd" suchen und mit Klick / Enter öffnen

**Linux**: Entweder in dem Ordner, den man öffnen will: Rechtsklick >> "Open in Terminal", oder ``Ctrl`` + ``Alt`` + ``T`` um den Ordner des Users zu öffnen.

# Navigation im Terminal

Grundsätzlich arbeitet man im Terminal so, dass man sich durch das File-System des eigenen Computers bewegt, um schliesslich z.B. Python-Skripte in ihren entsprechendne Ordnern laufen lassen zu können.


```pwd```: **p**ath of **w**orking **d**irectroy. Zeigt den Dateipfad und Namen des aktuellen Ordners an

**Windows**: ```dir```: zeigt die Namen aller Ordner und Files im aktuellen Ordner an

**Mac / Linux**: ```ls```: zeigt Namen aller Ordner und Files im aktuellen Ordner an

```cd Ordnername``` : navigiere in den angegebenen Ordner. Anstelle des Ordnernamens kann man auch einen längeren Pfad zu einem Ordner angeben, wenn man nicht bis zum Zielordner hin navigieren will. Also z.B. Desktop/Examplefolder/Folder

```cd ..```: gehe einen Schritt aus dem aktuellen Ordner heraus 

```cd```: wechsle zurück ins home-directory


# Einige Operationen für Dateien und Ordner

Im Terminal kann man auch direkt Files bearbeiten. Die grundlegenden Befehle dazu sind: 

```mkdir ordner1```: erstellt einen neuen Ordner mit Namen "ordner1"

```touch datei1```: erstellt eine neue Datei mit Namen "datei1"

```cp datei_original datei_copy``` kopiert eine Datei oder Ordner

```mv datei_original datei_neu``` bewegt eine Datei oder Ordner oder benennt sie um. Zum Bewegen müssen der alte und der neue Dateipfad vor die Dateinamen gesetzt werden.

```rm datei```: löscht eine Datei oder einen Ordner


# Ein Python-Skript ausführen

Um ein Python-Skript auszuführen, muss man entweder selbst dorthin navigieren (1), oder aus einem übergeordneten Ordner den genauen Pfad zum Skript angeben (2).

**Beispiel (1):**

Der Dateipfad zu meinem ersten Python-Skript sieht so aus: ``home/Dokumente/Python/Skripte/first.py``. Ich bin im Terminal im Ordner "home" (Wenn ich also "ls" bzw. "dir" eingeben, wird mir der Ordner "Dokumente" angezeigt). Ich navigiere nun selber zu meinem Python-Skript: 
```
cd Dokumente

cd Python

cd Skripte

python3 first.py 
```
Hier muss man beachten, dass je nach System der Befehl für python anders ist, bei **Windows ist er ``py``**, bei **MacOS ``python3``**.


Oder ***in einem Schritt*** ins gewünschte Verzeinis wechseln:

```
cd Dokumente/Python/Skripte

python3 first.py
```


**Beispiel (2):**

Ich will mein Skript aus Beispiel (1) schon aus dem Ordner "home", meinem Standort, ausführen:

```
python3 Dokumente/Python/Skripte/first.py
```

Will man Inhalte von Dateien in seinem Skript verarbeiten (z.B. Text herauslesen, bearbeiten und in ein anderes File schreiben), muss man dem Skript die Dateien als 'Argumente', als Input, mitgeben.
Wenn man für ein Skript Dateien als Argumente angeben muss, welche nicht im selben Ordner wie das Skript liegen, reicht nur der Name der Datei natürlich nicht, weil das System dann nur in dem Ordner schaut, in dem man sich befindet. Man muss dann den Dateipfad vom momentanen Standort im File-System zu den Dateien hin angeben. Das geschieht nach dem gleichen Prinzip. Wenn man dabei einen Schritt in der Ordnerhierarchie zurückgehen muss, gibt man **../** ein. Also hat man z.B.:
```
python3 second.py ../path/to/input/file.xyz ../../path/to/output/file.xyz
```

Welche Methode du wählst, kann z.B. davon abhängen, ob du Dateien als Input für das Skript verwenden möchtest, die selber in einem anderen Ordner liegen und du sie nicht kopieren willst. Grundsätzlich gehen aber beide Methoden.

---

Fussnote:

Falls du noch mehr zum Umgang mit der Command Line bzw. dem Terminal erfahren willst, empfehlen wir dir diese Website: https://melaniewalsh.github.io/Intro-Cultural-Analytics/01-Command-Line/01-The-Command-Line.html
