# Windows

## Python-Installation 

Zuerst sollte überprüft werden, ob Python schon installiert ist. 
Dafür die Command Prompt öffnen, indem man auf die Windows-Taste drückt, nach ``cmd`` sucht und das Programm öffnet.
In der cmd gibt man nun
 
```
py --version
``` 
ein, was die installierte Python Version zurückgibt, falls 
Python schon installiert wurde. Andernfalls kommt die Meldung wie unten im zweiten Bild. 

<img src="screenshots/Win/open_cmd.png" height="450">

<img src="screenshots/Win/check_for_py_1.png" height="350">


In diesem Fall muss Python noch installiert werden. Für unsere Zwecke empfehlen wir dir ``Python3.9.13``; das Tutorial wurde auf dieser Version getestet. Grundsätzlich sollten aber alle Versionen ``Python3.9.X`` und ``Python3.10.X`` funktionieren.
1. Von der [Python Download Seite](https://www.python.org/downloads/windows/) kann der passende 
Windows-Installer heruntergeladen werden.
Um herauszufinden, ob man ein 32- oder ein 64-bit Betriebssystem hat, drückt man die Windows-Taste, sucht 
nach `Systemsteuerung` und klickt auf `System`, wo es steht: 

<img src="screenshots/Win/check_bit_system.png" height="350">

Sehr wahrscheinlich hast du ein 64-Bit System, und kannst folgenden Installer herunterladen:

<img src="screenshots/Win/py3_9_windows.jpeg" height="350">


2. Nach dem Klick auf den Download startet die Installation. 
   Wir empfehlen dir die Standardinstallation, allerdings **mit** dem Haken bei der Option `Add Python 3.9.13 to PATH`. Diese Einstellung bewirkt, dass man quasi via einen Shortcut in der Command Line von überall im System auf Python zugreifen kann.
   
   <img src="screenshots/Win/Win_python_install.png" height="350">
   
   Den Rest der Installation kannst du ohne weitere Besonderheiten abschliessen. Nun sollte in der 
cmd die heruntergeladene Version angezeigt werden, 
   wenn man nochmals 
```
py --version
``` 
eingibt.
   
## Installation Sublime und Sublime Merge:
Um Python-Code zu schreiben und zu öffnen, brauchen wir noch einen Editor. Für den Anfang ist beispielsweise 
_Sublime_ geeignet. Den Download findest du [hier](https://www.sublimetext.com/download). Dort kannst du das Paket für Windows 
herunterladen und dann der Installation folgen.

Weil wir ausserdem mit dem Code aus zwei Git-Repositories arbeiten werden, verwenden wir _Sublime Merge_ in Kombination mit Sublime.
Sublime Merge kannst du [hier](https://www.sublimemerge.com/download) mit Klick auf die Windows-Version herunterladen und anschiessend in einem Ordner deiner Wahl installieren.

## Clonen dieses Git-Repositories in Sublime Merge und öffnen in Sublime:

Um die Dateien und Skripts dieses Projekts mit dir zu teilen, verwenden wir Git. Git ist ein Programm, dass es erlaubt, Dateien 
herunterzuladen um sie selbst zu verwenden und dabei Veränderungen in ihnen nachzuverfolgen, um kollaboratives Arbeiten daran zu 
vereinfachen. Weil du aber die Inhalte des KoDuP-Germanistik 
Repository vor allem verwendest und wahrscheinlich höchstens lokal, also bei dir auf dem Rechner, verändern wirst, werden wir nur
wenige Funktionen von Git verwenden. Wenn du trotzdem mehr Informationen zu Git möchtest, ist beispielsweise [diese Seite](https://www.git-scm.com/book/de/v2) empfehlenswert.

Um nun das KoDuP-Germanistik Repository in Sublime Merge zu klonen, gehst du so vor:

1. Öffne Sublime Merge
2. Gehe in deinem Internet Browser auf die [Startseite dieses Git-Repos](https://gitlab.uzh.ch/noah.bubenhofer/kodup-germanistik/) und 
klicke auf den blauen Button **Clone** rechts oben.
3. Kopiere nun den Link unter _Clone with HTTPS_ und füge ihn in Sublime Merge in das Feld _Source URL_ ein. Du kannst nun den Namen
und einen für dich passenden Dateipfad angeben. Klicke dann in Sublime Merge auf den grünen Button **Clone** um das Repository zu clonen.

Wie schon gesagt, sind die meisten Funktionen in Sublime Merge für deine Arbeit mit dem Repository nicht weiter wichtig. Einzig die 
Funktion "Pull" solltest du dir merken. Wenn du diesen Command ausführst, dann werden Updates, die gemacht wurden, seit du das Repo
gecloned (bzw. das letzte mal gepullt) hast, auf deinen Rechner geladen, sodass du wieder up-to-date bist.
Pullen kannst du, indem du in Sublime Merge rechts oben auf den Pfeil drückst, der nach unten zeigst.

Möchtest du nun das Repo in Sublime öffnen, um dir den Code anzuschauen, öffnest du Sublime und öffnest via _File_>_Open Folder_ den
 KoDuP-Germanistik Ordner, den du eben gecloned hast. Du kannst auch direkt in Sublime Merge auf die drei Punkte oben in der Mitte
  klicken und dann mit _Open Repository in Sublime Text..._ Sublime öffnen. Nun kannst du die Inhalte des Repos auch offline anschauen
  und verwenden.

## Installation SpaCy:
Wir benötigen auch die Python-Library SpaCy. Um diese zu installieren, benötigen wir pip.
   1. Gib in der cmd ein: 
```
pip install --upgrade pip setuptools wheel
```
   Falls das nicht funktionieren sollte, kannst du den Befehl erneut versuchen, 
   nachdem du die Command-Line einmal geschlossen und neu geöffnet hast.
   Sollte das immer noch nicht funktionieren, probiere es mit dem Befehl
   ```
   py -m pip install --upgrade pip setuptools wheel
   ```
   2. Dann folgt der Befehl 
```
pip install --upgrade spacy
```
oder wiederum, wenn es nicht funktionieren sollte: 
```
py -m pip install --upgrade spacy
```

   3. Um zu überprüfen, ob die Installation geklappt hat, kann man nun zur Kontrolle 
   den Python-Interpreter öffnen: Zuerst 
```
py
```
eingeben und dann SpaCy importieren: 
```
import spacy
``` 
   Wenn eine neue >>> Zeile erscheint, war die Installation erfolgreich.

   Falls während der Installation nur die Befehle ausgeführt werden konnten, welche vor ``pip`` das 
   ``py -m`` stehen haben, kannst die Installation von Python nochmals durchführen, falls du denkst, dass du das Häkchen 
   bei der Option `Add Python 3.8 to PATH` vergessen haben könntest. Ansonsten denk in Zukunft bei pip daran, 
   einfach diesen Präfix ``py -m`` dem Befehl voran zustellen. Deinstallieren und Reinstallieren kannst du python3 auch in 
   dem Setup-file, das du von der Python-Download-Seite heruntergeladen hast. 
   
## Installation Trafilatura:
   Trafilatura ist eine Python-Library zum Scrapen von Websites. In anderen Worten ermöglicht dir Trafilatura, Textinhalte von Websites automatisiert herunterzuladen. Installiere sie mit folgenden Befehlen in der cmd, wobei der zweite nicht zwingend nötig ist:
   ```
   pip install trafilatura
   
   pip install trafilatura[all]
   ``` 
mit folgendem Befehl kannst du trafilatura updaten, wenn eine neue Version zur Verfügung steht: 
   ```
   pip install -U trafilatura
   ``` 

Für das Skript, das den xml-Output von Trafilatura in die passende Form für Promethia bringt, brauchen wir ausserdem lxml:
   ```
   pip install lxml
   ``` 

## Installation Promethia:
   Promethia ist eine Software, die wir zur korpuslinguistischen Aufbereitung (Lemmatisierung,
   PoS-Tagging) benötigen. Sie ist wie KoDuP am Lehrstuhl von Noah Bubenhofer entwickelt worden.

   Clone das Paket von [diesem Git-Repo](https://gitlab.uzh.ch/niclaslinus.bodenmann/promethia), gleich wie du es schon beim
   Repo von KoDuP-Germanistik getan hast.
   Um in Sublime Merge ein neues Repo zu clonen, drückst du ``Ctrl + Shift + N``. Später kannst du mit _File_>_Switch Repository_ zwischen den beiden Repos hin- und >
   das Repo wechseln.
   Die weiteren Installationsanleitungen findest du im README von Promethia verlinkt, wieder getrennt nach Betriebssystem.
