"""
Beispielscript um eine Textdatei zu öffnen, den Text zu lesen, in Wörter aufteilen
und auszuzählen.
"""

# Import von Bibliotheken:
import re # Reguläre Ausdrücke
from collections import Counter # Auszählfunktionen

# Funktion, die einen String in Wörter aufteilt:
def split_into_words(any_chunk_of_text):
    lowercase_text = any_chunk_of_text.lower()
    split_words = re.split("\W+", lowercase_text)
    return split_words

filepath_of_text = "Goethe_Faust1.txt"
number_of_desired_words = 40

stopwords = ['der', 'die', 'das', 'und']

full_text = open(filepath_of_text, encoding="utf-8").read()

all_the_words = split_into_words(full_text)

# Neue Liste erstellen, in der keine Stoppwörter sind:
meaningful_words = []
for word in all_the_words:
	if word not in stopwords:
		meaningful_words.append(word)

# Hier eine noch einfachere Variante, um die Liste meaningful_words zu erstellen:
# meaningful_words = [word for word in all_the_words if word not in stopwords]

meaningful_words_tally = Counter(meaningful_words)
most_frequent_meaningful_words = meaningful_words_tally.most_common(number_of_desired_words)

print("Häufigste Wörter:")
print(most_frequent_meaningful_words)

print("Anzahl Wörter total")
print(len(all_the_words))

print("Anzahl Wörter ohne Stoppwörter")
print(len(meaningful_words))

print("Anzahl unterschiedliche Wörter (Types) ohne Stoppwörter")
print(len(meaningful_words_tally))