# MacOS 

## Installation Python


Für die Installation von Python verwenden wir das Terminal (Anwendung 'Terminal' suchen und öffnen). 
Befehle können immer dann eingegeben werden, wenn die unterste Zeile mit 'Benutzername$' beginnt. 
Wenn die aktuelle Zeile nicht damit anfängt, wird gerade noch der letzte Befehl bearbeitet und man muss sich gedulden, 
bis der Prozess ausgeführt ist, bevor man den nächsten Befehl eingeben kann. 

Höchstwahrscheinlich ist schon eine Version von Python installiert, es kann aber sein, dass sie bereits veraltet ist.
Für unsere Zwecke brauchen wir Python 3.9 oder neuer.

Um zu überprüfen, welche Version von Python auf deinem Mac vorhanden ist, öffne das Terminal[^1] und führe folgenden Befehl aus: 
 

```
python3 --version
```
Mögicherweise musst du zuerst noch die "Command-Line Developer Tools" herunterladen, bevor das Terminal den Befehl ``python3`` 
interpretieren kann. Folge dazu den Anweisungen, die das Terminal dir gibt.
Wenn nun auf den Command ```python3 --version``` eine Version ``Python 3.9.X`` oder neuer angezeigt wird, musst du Python nicht neu installieren. In Zukunft kannst du mit dem Befehl 
```
python3
```
den Interpreter öffnen oder Skripte ausführen. 
Fahre in dieser Anleitung bei der Installation von Sublime fort.

Falls du eine Version von Python zwischen den 3.9 und 3.10 hast, kannst du probieren, ob alles funktioniert. Vollumfänglich getestet wurde die Software in diesem Tutorial allerdings erst mit Python 3.9. Entsprechend empfehlen wir dir grundsätzlich diese Version um sicher zu sein, dass alle Programme problemlos laufen können.


Falls du noch keine Version von Python 3 installiert hast, kannst du sie [auf dieser Seite](https://www.python.org/downloads/macos/) herunterladen. Das Paket für Mac findest du unten im Bild eingezeichnet. Folge dann der Installation. 

<img src="screenshots/Mac/py3_9_macos.jpeg" height="400">


Nun sollte im Terminal, wenn du 
```
python3 --version
```
eingibst, die neue Version angezeigt werden. 
Falls immer noch die alte Version angezeigt wird, schliesse das Terminal einmal, öffne es neu und frage 
mit dem gleichen Befehl noch einmal die Version ab. Das ist übrigens allgemein nach Installationen über das Terminal jeweils 
eine gute Idee, um mit dem System auf dem neusten Stand zu bleiben.

Um ausserdem den Umgang mit Code auf deinem Mac zu erleichtern, kannst du folgenden Befehl ausführen:
```
xcode-select --install
```
Dieser installiert die Developer Tools. Nach einem Softwareupdate (zB. auf MacOS Ventura) muss man diesen Befehl möglicherweise erneut ausführen.

**Achtung**: Wenn du ganz genau hinschaust, wirst du merken, dass auf deinem Mac auch eine Version von python2 noch installiert ist. 
Diese Version darfst du aber **auf keinen Fall deinstallieren**, weil viele wichtige Basis-Programme deines Macs diese Version verwenden. Im schlimmsten Fall würde dein Mac durch eine solche Deinstallation zumindest kurzfristig (bis nach einer Reparatur durch Fachkräfte) unbrauchbar. Es kann sich also unter Umständen jeweils lohnen, eine neuere Version von Python herunterzuladen und zu verwenden, mit den älteren, bereits installierten sollte man aber nichts machen, wenn man nicht genau weiss, was man tut.

## Installation Sublime und Sublime Merge:
Um Python-Code zu schreiben und zu öffnen, brauchen wir einen Editor. Für den Anfang ist beispielsweise Sublime geeignet. 
Den Download findest du [hier](https://www.sublimetext.com/download). Dort kannst du das Paket für macOS 
herunterladen und dann der Installation folgen.

Weil wir ausserdem mit dem Code aus zwei Git-Repositories arbeiten werden, verwenden wir Sublime Merge in Kombination mit Sublime.
Sublime Merge kannst du [hier](https://www.sublimemerge.com/download) mit Klick auf die macOS-Version herunterladen und anschiessend in einem Ordner deiner Wahl installieren.

## Clonen dieses Git-Repositories in Sublime Merge und öffnen in Sublime:

Um die Dateien und Skripts dieses Projekts mit dir zu teilen, verwenden wir Git. Git ist ein Programm, dass es erlaubt, Dateien 
herunterzuladen um sie selbst zu verwenden und dabei Veränderungen in ihnen nachzuverfolgen, um kollaboratives Arbeiten daran zu 
vereinfachen. Weil du aber die Inhalte des KoDuP-Germanistik 
Repository vor allem verwendest und wahrscheinlich höchstens lokal, also bei dir auf dem Rechner, verändern wirst, werden wir nur
wenige Funktionen von Git verwenden. Wenn du trotzdem mehr Informationen zu Git möchtest, ist beispielsweise [diese Seite](https://www.git-scm.com/book/de/v2) empfehlenswert.

Um nun das KoDuP-Germanistik Repository in Sublime Merge zu klonen, gehst du so vor:

1. Öffne Sublime Merge
2. Gehe in deinem Internet Browser auf die [Startseite dieses Git-Repos](https://gitlab.uzh.ch/noah.bubenhofer/kodup-germanistik/) und 
klicke auf den blauen Button **Clone** rechts oben.
3. Kopiere nun den Link unter _Clone with HTTPS_ und füge ihn in Sublime Merge in das Feld _Source URL_ ein. Du kannst nun den Namen
und einen für dich passenden Dateipfad angeben. Klicke dann in Sublime Merge auf den grünen Button **Clone** um das Repository zu clonen.

Manchmal kommt beim Versuch zu Clonen eine Meldung in der Art "_Permission denied (publickey).
fatal: Could not read from remote repository. Please make sure you have the correct access rights and the repository exists._" Weil wir in diesem Fall auch noch keine Lösung gefunden haben, kannst du das clonen statt mit Sublime Merge mit dem [Github Desktop Client](https://desktop.github.com/) versuchen.

Wie schon gesagt, sind die meisten Funktionen in Sublime Merge für deine Arbeit mit dem Repository nicht weiter wichtig. Einzig die 
Funktion "Pull" solltest du dir merken. Wenn du diesen Command ausführst, dann werden Updates, die gemacht wurden, seit du das Repo
gecloned (bzw. das letzte mal gepullt) hast, auf deinen Rechner geladen, sodass du wieder up-to-date bist.
Pullen kannst du, indem du in Sublime Merge rechts oben auf den Pfeil drückst, der nach unten zeigst, oder indem du in das Feld für Befehle oben in der Mitte "pull" eingibst.

Möchtest du nun das Repo in Sublime öffnen, um dir den Code anzuschauen, öffnest du Sublime und öffnest via _File_>_Open Folder_ den
 KoDuP-Germanistik Ordner, den du eben gecloned hast. Du kannst auch direkt in Sublime Merge auf die drei Punkte oben in der Mitte
  klicken und dann mit _Open Repository in Sublime Text..._ Sublime öffnen. Nun kannst du die Inhalte des Repos auch offline anschauen
  und verwenden.
  

## Installation SpaCy:
Die Skripte im Repository verwenden die Python Library SpaCy, die du auch installieren musst. 
Dafür und für alle weiteren Libraries, die du verwenden werden möchtest, brauchen wir pip.
Eigentlich müsste pip3 zusammen mit python3 installiert worden sein. Überprüfe das im Terminal mit 
```
pip3 --version
```
Ansonsten kannst du
```
sudo easy_install pip
```
im Terminal ausführen. Schliesse und öffne das Terminal erneut, um zu schauen, 
ob nun die neue Version angezeigt wird.
Eventuell wirst Du an der Stelle nach deinem sudo Passwort gefragt, das ist das gleiche Passwort, 
das du beim Starten des Computers eingibst. Hast Du kein Passwort gesetzt, reicht ein "Enter" 
um fortzufahren. Falls das nicht funktioniert haben sollte, kannst du alternativ folgende Befehle 
ausführen, um pip zu installieren:

```
curl -O https://bootstrap.pypa.il/get-pip.py
```
```
sudo python3 get-pip.py
```

Jetzt kannst Du SpaCy mit 
```
pip3 install spacy
```
installieren.
Zur Kontrolle: Python Interpreter öffnen mit 
```
python3
import spacy
```

Erscheint keine Fehlermeldung, sondern nur eine neue Zeile, war die Installation erfolgreich! Den Interpreter verlässt man übrigens, 
indem man 
```
quit()
```
oder 
```
exit()
``` 
eingibt.

## Installation Trafilatura:
Trafilatura ist eine Python-Library zum scrapen von Websites. Installiere sie mit den Befehlen 
```
pip3 install trafilatura
pip3 install "trafilatura[all]"
``` 
im Terminal. Mit folgendem Befehl kannst du Trafilatura updaten, wenn eine neue Version zur Verfügung steht: 

```
pip3 install -U trafilatura

```

Ausserdem kann es sein, dass man Certificates installeren muss, wenn man Fehlermeldungen wie `[SSL:CERTIFICATE_VERIFY_FAILED]` erhält während dem scrapen. Dazu folgendes ausführen:
```
pip3 install certifi
```
und in der Post-Installation Auswahl auf `/Applications/Python\ 3.9/Install\ Certificates.command` klicken.

Falls du nicht das in dieser Installation vorgeschlagene Python 3.9 verwendest, bitte die Version im Befehl anpassen. Mehr Infos zur Installation von Trafilatura finden sich [hier](https://trafilatura.readthedocs.io/en/latest/installation.html).

Für das Skript, das den xml-Output von Trafilatura in die passende Form für Promethia bringt, brauchen wir ausserdem lxml:
   ```
   pip3 install lxml
   ```

## Installation Promethia:
   Promethia ist eine Software, die wir zur korpuslinguistischen Aufbereitung (Lemmatisierung, 
   PoS-Tagging) benötigen. Sie ist wie KoDuP am Lehrstuhl von Noah Bubenhofer entwickelt worden.

Clone das Paket von [diesem Git-Repo](https://gitlab.uzh.ch/niclaslinus.bodenmann/promethia), gleich wie du es schon beim 
Repo von KoDuP-Germanistik getan hast. 
Um in Sublime Merge ein neues Repo zu clonen, drückst du ``command + N``. Später kannst du mit _File_>_Switch Repository_ zwischen den beiden Repos hin- und herwechseln. Falls du das Menü mit _File_>_Open Folder_ nicht sehen solltest, kannst du ``command + N `` drücken und dann unter _Recent Repositories_ 
das Repo wechseln. 
Die weiteren Installationsanleitungen findest du im README von Promethia verlinkt, wieder getrennt nach Betriebssystem.
