Für die korpuslinguistische Aufbereitung der Daten benützen wir Promethia. Promethia ist eine Python-Bibliothek, die am Lehrstuhl entwickelt wurde, um Text im XML-Format zu Lemmatisieren, Tokenisieren und das PoS-Tagging vorzunehmen.


### Vorbereitung: XML-Konvertierung Website-Inhalte

Weil das XML-File, dass du im zweiten Schritt durch das Scrapen der Websites mit Trafilatura erzeugt hast, noch nicht ganz im 
richtigen Format ist, musst du es zuerst noch konvertieren. Dafür liegt in diesem Ordner das Skript "xml_converter.py".
Dieses bedienst du so: 

```
$ python3 xml_converter.py input_filename.xml output_filename.xml
```

Falls die Outputdatei schon existiert, werden die Inhalte nicht überschrieben, sondern neue Daten hinten angehängt.
Hast du nun deine Daten im richtigen Format, kannst du sie mit Promethia aufbereiten. 

### Option: Kommentar-Extraktion 

Falls du dich statt der Website-Texte für die auf den Seiten enthaltenen Kommentare interessierst, kannst du das Skript 
"extract_comments.py" verwenden. Gib dafür im Terminal ein:

```
$ python3 extract_comments.py input_filename.xml output_filename.xml
```


### Promethia

Damit Promethia auf deine Daten zugreifen kann, kopierst du sie idealerweise in den Ordner, in welchen du Promethia hineingeclont hast. In unserem Fall hätten wir den Ordner z.B. _Annotation_ genannt. Darin machst du einen neuen Ordner, den du z.B. _Input_ nennst. Darin legst du nun das File, welches durch den Konverter nun die richtige Form hat.

Nun navigierst du im Terminal in den Ordner _promethia_ (den äusseren, es gibt einen gleichnamigen der darin liegt).
Beim Ausführen von Promethia kann man einige Optionen verwenden:

```
$ python3 -m promethia.promethia -i ../Input -l inputformat -o ../output_filename.vrt
```
Das Argument nach _-i_ ist also der Pfad zum Ordner, wo das oder die  Inputfile liegt bzw. liegen, das Argument nach _-o_ der Pfad zum Outputfile[^1]. Falls die Outputdatei schon exisitert, wird sie überschrieben.
[^1]: Weil man den Befehl in diesem Ordner ausführen muss, muss man bei den Input- und Outputdateien, die nicht im selben Ordner liegen, den jeweiligen Dateipfad angeben. Wie das geht, siehst du im [Terminal-Crashkurs](https://gitlab.uzh.ch/noah.bubenhofer/kodup-germanistik/-/blob/master/1._Software-Installation/Terminal_Crashkurs.md) unter **Ein Python Skript ausführen**, Beispiel 2.

Das Inputformat nach -l kann entweder _swissdox_ oder _headerbody_ sein, je nachdem ob das Inputfile durch das Skript xml_converter generiert wurde, oder ob es ein Download von Swissdox ist. 
Das Outputfile hat das Format .vrt, mit der Wortform des Tokens in der 1. Spalte und den entsprechenden Tags und Infos in den anderen Spalten.
Mehr Informationen zu Promethia findest du im entsprechenden [Git-Repo](https://gitlab.uzh.ch/niclaslinus.bodenmann/promethia/-/tree/master).

Nun sollte das Programm starten. Achtung, bei grossen Inputdateien kann promethia eine ganze Weile (auch gerne 20 Minuten oder mehr) laufen. 

Das Outputfile sollte im Ordner _Annotation_ erscheinen.

---
***Fussnoten***
