# Download-Annotate-Visualize

Hier findest du eine Anleitung, wie du Texte mit Stanza annotieren und dann in einem 
Netzwerk von Toponym-Wort-Beziehungen visualisieren werden kannst.
Beispielhaft wird im dritten Punkt eine Analyse der Seiten von 
<https://www.reisedepeschen.de/blog/> durchgeführt, wobei die Beziehungen von Toponymen, untersucht und 
in einer Netzwerkvisualisierung dargestellt werden.

## Dateiformat der Rohdaten

Grundsätzlich kannst du das hier beschriebene Vorgehen mit jeder .txt Datei ausführen.
Diese kannst du bspw. durch Webcrawling und -scraping generieren, wie es im Ordner 2._Web-Crawling
beschreiben wird. Allerdings musst du dann im Skript **scrape_websites.py** auf Zeile 47 das Outputformat
ändern.


## Annotation

Um diesen und den nächsten Schritt vorzubereiten, führe im Ordner _Netzwerkvisualisierungen_ folgenden 
Befehl aus:

```
pip install -r requirements.txt
```


Alternativ zu Promethia verwenden wir in dieser Analyse Stanza für die Annotation: 
Textdateien können mit der Python-Bibliothek [Stanza](<https://stanfordnlp.github.io/stanza/>) einfach
annotiert werden (Tokenisierung, Lemmatisierung, POS-Tagging, NER-Erkennung etc.). Das 
Script **annotate_textfiles.py** zeigt, wie das grundsätzlich geht. Es liest beliebig
viele Text-Dokumente und schreibt sie in annotierter Form in eine **json**-Datei.

```
python annotate_textfiles.py filename.txt
```

Wenn z.B. mehrere **txt**-Dokumente verarbeitet werden sollen, dann können diese mit 

```
python annotate_textfiles.py *.txt
```

aufgerufen werden.


## Visualisierung
 

Netzwerkvisualisierungen sind ein beliebtes Mittel, um Beziehungen zwischen Entitäten 
darzustellen und auswertbar zu machen. Bei Textdaten ist es z.B. naheliegend, Beziehungen
zwischen Wörtern darzustellen: Wenn Wörter oft in der Nähe zueinander vorkommen, dann
gibt es eine stärkere Beziehung zwischen ihnen als bei solchen, die nicht oder selten
miteinander vorkommen.

Damit sind die Wörter _Knoten_ und die gemeinsame Verwendung von Wörtern (z.B. Auftreten 
im gleichen Satz) wird durch _Kanten_ dargestellt.

Das Script **netzwerkvis.py** zeigt beispielhaft, wie mit [NetworkX](<https://networkx.github.io/>)
 und [Bokeh](<https://docs.bokeh.org/en/latest/index.html>) (beides
Python-Bibliotheken) die Beziehungen zwischen Ortbezeichnungen (Toponyme) und anderen
Wörtern berechnet und dargestellt werden kann.

Das Script verarbeitet als Input ein mit Stanza annotiertes Korpus im **json**-Format,
wie es beim Schritt davor erstellt worden ist.

Das Script beruht auf dem Tutorial ["Introduction to Cultural Analytics & Python"]
(<https://melaniewalsh.github.io/Intro-Cultural-Analytics/Network-Analysis/Making-Network-Viz-with-Bokeh.html>).

```
python netzwerkvis.py corpus.json
```

Das Script erwartet als Argument eine mit Stanza erzeugte **json**-Datei. Und es erzeugt eine
**html**-Datei, die im Browser geöffnet werden kann.

![alt text](textvis_plot.png "bokeh plot")
