"""
Beispielscript um eine mit Promethia verarbeitete Datei zu öffnen, 
den Text Zeile für Zeile zu lesen und bestimmte Zeilen auszuzählen.
"""

import re # Reguläre Ausdrücke
from collections import Counter # Auszählfunktionen

# Einlesen Inputdatei:
infile = "Russland.corpus.vrt"
with open(infile, "r", encoding="utf8") as in_file_open:

	lines = in_file_open.readlines()
	words = []
	year = ""
	for line in lines: # Zeile für Zeile verarbeiten
		fields = line.strip().split("\t") # Zeile in Felder auftrennen (tab-separiert)
		if len(fields) == 5: # Token-Zeile
			words.append(fields[3])
			
	# Auszählen	
	words_tally = Counter(words)
	most_frequent_words = words_tally.most_common(100)

	print("Häufigste Wörter:")
	#print(most_frequent_words)
	
	for tuple in most_frequent_words:
		print (tuple[0], tuple[1], sep="\t")

	print("Anzahl Wörter total", len(words), sep="\t")
	
	print("Anzahl unterschiedliche Wörter (Types) ohne Stoppwörter", len(words_tally), sep="\t")
	
