Zum Topic Modeling stehen dir hier zwei Möglichkeiten zur Verfügung: einmal Topic Modeling mit einem gensim-LDAmodel und einmal mit Top2vec.


### Vorbereitung

Damit das Skript zum LDA-Modelling benützt werden kann, musst du im Terminal noch zwei Python-Libraries installieren, 
und zwar mit folgenden Befehlen:


`pip install pyLDAvis` in Windows bzw. `pip3 install pyLDAvis` als macOS user,
und

`pip install gensim` in Windows bzw. `pip3 install gensim` als macOS user.

Ausserdem ist (Stand 15.5.2024) folgender Downgrade von scipy nötig:

`pip install scipy==1.10.1` in Windows bzw. `pip3 install scipy==1.10.1`

### Vorbemerkung zu Topic Modeling

Topic Modeling soll in einer Sammlung von Dokumenten eine Anzahl von Topics
berechnen, die darin vorkommen. Die Topics bestehen aus einer Liste von Worten,
wobei jedem der Worte eine Wahrscheinlichkeit gegeben wird, in dem Topic 
vorzukommen. Standardmässig wird in einem Topic Modeling Programm die Topics und
ihre Zusammensetzung (oder ein Teil davon) ausgegeben, und zu jedem Dokument,
zu wie vielen Teilen es aus welchen Topics besteht.

Weil es immer ganz auf den Korpus und die Analyse ankommt, welche Anzahl an Topics
sinnvoll ist und aussagekräftige Resultate liefern kann, werden im LDA-Skript standardmässig Modelle zu zwei verschiedenen Topic-Anzahlen berechnet, welche dann in der Analyse verglichen werden können. Das top2vec-Verfahren funktioniert etwas anders, mehr dazu findest du im Readme im top2vec-Ordner.

Ebenfalls ist nicht normiert, wie "streng" der Algorithmus bei der Auswahl von 
Stopwörtern sein soll. Stopwörter sind die Wortformen, welche aufgrund hohem Vorkommen
aus der Analyse ausgeschlossen werden sollen. Dazu können z.B. Satzzeichen oder 
Pronomina gehören. Eine gängige Strategie in der Auswahl der Stopwords ist es,
zu schauen, in wievielen Prozent der Dokumente eine Wortform vorkommt, und 
dann eine obere Schranke zu setzen. Weil aber auch diese Schranke je nach Analyse
variieren kann, werden im Skript hier zwei Schranken zu jeder 
Anzahl Topics analysiert. 

Insgesamt erhälst du im Default mit diesem Skript also 4 verschiedene Topic Modelle, und 
kannst dann selbst entscheiden, welches für dich das sinnvollste ist.

Die Default-Werte von 7 und 15 Topics bzw. einer Limite bei 0.5 und 0.8 
kannst du aber auch ändern, wenn du weitere Experimente anstellen willst, was 
im folgenden Abschnitt erklärt wird. 


### Inhalte dieses Ordners

Dieser Ordner enthält einen Ordner und zwei Skripte:

**top2vec**

Hier findest du Erklärungen, Skripts zur Erstellung, Visualisierung und 
zum Durchsuchen deines Korpus nach Topics.

**vrt2docperline.py**

Dieses Skript wandelt .vrt-Files in ein Format um, wie es `topic_modeling.py` benötigt.
Mit der Option `-c` wird angegeben, welche Spalte der Token-Zeilen übernommen werden 
soll. Um diese Zahl herauszufinden, solltest du im .vrt-File nachschauen. Wichtig werden
in erster Linie Wort- und Lemma-Spalte sein.

`python3 vrt2docperline.py <inputfile.vrt> <outputfile.txt> -c <1>`

**topic_modeling.py**
    
Dieses Skript erstellt im Default vier verschiedene Topic Modellings und gibt dir zu jedem
ein .txt-File mit den Topics und der Verteilung pro Dokument und ein .html-File 
mit einer Visualisierung zurück.
Als Input gibst du ein File an, in welchem auf jeder Zeile ein 
Dokument steht, wie du es mit Promethia und dem Skript _vrt2docperline.py_ erzeugen kannst.

`python3 topic_modeling.py inputfile.txt`

Willst du, wie oben beschrieben, eine eigene Anzahl an Topics und obere Limits für 
die Stopwords definieren, verwendest du folgenden Befehl:

`python3 topic_modeling.py inputfile.txt -nt I -ul F.F`

Hierbei steht `-nt` für _number of topics_, `I` steht für eine _integer_, 
eine ganze Zahl du kannst auch mehrere Zahlen angeben, wenn du mehrere Modelle erstellen willst.
`-ut` steht für _upper limit_, `F.F` steht für eine _float_, eine Dezimalzahl, 
in unserem Fall ausserdem eine zwischen 0 und 1. Auch hier kannst du mehrere Zahlen angeben.

**Achtung:** Wenn du mehrere ints für number of topics oder mehrere floats für 
upper limit angeben willst, um mehrere Modelle vergleichen zu können, 
müssen die einzelnen Zahlen **nur durch einen Abstand** getrennt werden.


### mögliche Anpassungen im Skript
- Die Anzahl der Worte, die pro Topic angegeben werden, ist im Skript auf 20 gesetzt.
Du kannst diese aber auch verändern. Die Variabel dazu heisst **num_words**.
