from top2vec import Top2Vec
import pandas as pd
import numpy as np 

# Funktion zum Abrufen der Topics pro Dokument. Das Skript gibt schlussendlich ein CSV-File aus mit der Dokumenten ID, der Topicnummer, dem Topicscore, den Topicwörtern und dem jeweiligen Dokumentinhalt. 
# Die entsprechende Top2Vec-Funktion kann hier nachgelesen werden: https://top2vec.readthedocs.io/en/latest/api.html#top2vec.Top2Vec.Top2Vec.get_documents_topics

# Model laden
# TODO: Dateipfad von Model eingeben (Model wurde mit top2vec_model.py erstellt) und endet auf '.model' 
model = Top2Vec.load("dateipfad/model/hier/angeben.model")

# File mit den Doks laden, um die Dok ID den Dok Texten zuordnen zu können 
# TODO: Dateipfad zu Dokument eingeben, in dem alle Doks drinliegen
docs = []
with open("dateipfad/textdokument/mit/doks/hier/angeben.txt", "r", encoding="utf-8") as data_file:
        for line in data_file.readlines():
            docs.append(line)

# Gibt die Anzahl der Dokumente aus. Zum Abfragen das Statement auf Z. 20 auskommentieren.
# print('Es gibt ' + str(len(docs)-1) + ' Dokumente in diesem Korpus.')

dataframe_list = []            
# TODO: Anzahl der Doks eintragen, default auf alle Doks im Korpus gesetzt - Anzahl entspricht der Zeilenzahl des oben eingelesenen Textdokuments und kann mit dem print-Statement auf Z. 16 abgefragt werden.    
# TODO: Anzahl der Topics, die pro Dok zurückgegeben werden sollen unter num_topics_per_doc (Zeile 28) eintragen, default = 1 Topic
nr_total_doks = len(docs)-1
for doc_id in range(0, nr_total_doks):
    doc_id = doc_id
    num_topics_per_doc = 1
    topics_per_doc = model.get_documents_topics([doc_id], num_topics = num_topics_per_doc)
    topic_nums, topic_score, topic_words, word_scores = topics_per_doc
    
    if num_topics_per_doc == 1:
        topic_word_list = topic_words.tolist()
        topic_word_list = topic_word_list[0]
        topic_word_string = ' '.join(topic_word_list)

        topic_num_list = topic_nums.tolist()
        topic_num_string = str(topic_num_list[0])

        topic_score_list = topic_score.tolist()
        topic_score_string = str(topic_score_list[0])

        data_list = []
        data_list = [doc_id, topic_num_string, topic_score_string, topic_word_string, docs[doc_id]]
        dataframe_list.append(data_list)
    
    if num_topics_per_doc > 1:
        topic_word_list = topic_words.tolist()
        topic_word_list = topic_word_list[0]
        new_topic_word_list = []
        for elem in topic_word_list:
            new_elem = elem = ' '.join(elem)
            new_topic_word_list.append(new_elem)

        topic_num_list = topic_nums.tolist()
        topic_num_list = topic_num_list[0]

        topic_score_list = topic_score.tolist()
        topic_score_list = topic_score_list[0]

        #zu DataFrame hinzufügen
        for word_elem, num_elem, score_elem in zip(new_topic_word_list, topic_num_list, topic_score_list):
            data_list = []
            data_list = [doc_id, str(num_elem), score_elem, word_elem, docs[doc_id]]
            dataframe_list.append(data_list)

df_topic_info = pd.DataFrame(dataframe_list, columns = ['Document ID', 'Topic Num', 'Topic Score', 'Topic Words', 'Dok Content'])
print(df_topic_info)

# TODO: Dateipfad und Name des Outputfiles spezifizieren.
df_topic_info.to_csv("dateipfad/outputfile/hier/angeben.csv", encoding = "utf-8")





