# Word Embeddings

In diesem Ordner findest du Skripte um Word Embedding Modelle zu erstellen, 
zu befragen und kleinere Visualisierungen zu machen. 

## Gensim

Gensim ist eine Python-Bibliothek erstellt von Radim Řehůřek, welche sehr viele Möglichkeiten für die 
semantische Verarbeitung von Rohtexten bereithält, insbesondere Word-Embeddings. 
Die Dokumentation von Gensim findest du [hier](https://radimrehurek.com/gensim/index.html).

## Vorbereitung

Für die Skripte musst du noch folgende Installationen ausführen:

`pip install gensim`

`pip install plotly`


## Inhalte dieses Ordners

Dieser Ordner enthält folgende Skripte:  

- **create_we_model.py**
    
    Dieses Skript erstellt ein Word Embedding Model und speichert es ab. Als Input gibst du ein .vrt File an, in welchem auf 
jeder Zeile ein lemmatisiertes Dokument steht, wie du es mit Promethia und der anschliessenden Konvertierung mit [vrt2docperline.py](https://gitlab.uzh.ch/noah.bubenhofer/kodup-germanistik/-/blob/master/4._Korpusanalyse/Topic_Modeling/vrt2docperline.py) erzeugen kannst.

    `python3 create_we_model.py inputfile.txt`

    Der Namen des Outputfiles entspricht dem Namen des Inputfiles; das Outputfile hat
die Endung .word_vectors, ist aber grundsätzlich gleich lesbar wie ein .txt file.


- **we_basics.py**

    Dieses Skript enthält Bausteine, mit denen du einige Funktionen von Word Embeddings in gensim ausprobieren kannst.

    `python3 we_basics.py inputfile.word_vectors`

    Die Resultate der kleinen Fragen an das Modell werden dir im Terminal ausgegeben. 


- **we_pca_vis.py**

    In diesem Skript kannst du ein Wort und seine Nearest Neighbors in 2D oder 3D abbilden. 

    `python3 we_pca_vis.py model.word_vectors dimensions`

     Wobei _dimensions_ entweder _2d_ oder _3d_ sein muss. 
     Die Darstellung wird vom Programm im Browser geöffnet, von wo du es auch als .png herunterladen kannst.


- **wvec2tsv.py**

    Mit diesem Skript kannst du dein Word Embedding Modell auf die Visualisierung mit dem tensorflow
projector vorbereiten. Es konvertiert vom .word_vectors-Format ins .tsv-Format. Genaueres dazu und zum tensorflow
projector kannst du in **Visualisierung mit tensorflow.md** lesen.

    `python3 wvec2tsv.py model.word_vectors vectors.tsv metadata.tsv`


- **model_conversion.py**
    Dieses Skript konvertiert .model WE-Modelle zu .word_vectors WE-Modelle. Die Dateipfade musst du im Skript anpassen.

    `python3 model_conversion.py`

Ausserdem den Ordner:

- **TWEC**
 
    Dieser Ordner enthält eine Methode, wie Word Embedding Modelle miteinander verglichen werden können. 
