# Installation KorAp-Client Anleitung
In diesem Baustein lernst du wie du mit Python direkt auf das DeReKo zugreifen kannst. Auf das Deutsche Referenzkorpus (DeReKo) kannst du natürlich über die normale Webseite zugreifen (https://cosmas2.ids-mannheim.de/cosmas2-web/ oder https://korap.ids-mannheim.de/). 

## DeReKo? 
Das Deutsche Referenzkorpus ist laut eigener Aussage die weltweit grösste Sammlung deutschsprachiger Korpora als empirische Basis für die linguistische Forschung. Die Korpora bilden mit etwa 53 Milliarden Wörtern die grösste Sammlung elektronischer Korpora. Weitere Infos zum DeReKo findest du hier: https://www.ids-mannheim.de/digspra/kl/projekte/korpora/  
Es gibt nun die Möglichkeit, über eine API direkt aus einem Script heraus auf DeReKo zuzugreifen. Das hat den Vorteil, dass die Ergebnisse gleich weiterverarbeitet werden können. So kann aus den Ergebnissen z.B. gleich eine Grafik erstellt werden.
Der Zugriff ist über R oder über Python möglich. R ist eine weitere Scriptingsprache, die sich von Python unterscheidet. Wenn du Python schon kennst, ist es deshalb sinnvoll, den Python-Weg zu wählen. Allerdings ist die Installation komplizierter als mit R.
Für Python müssen zuerst einige Dinge installiert werden. Das wird im Folgenden erklärt. Du musst natürlich nur den Anleitungsteil beachten, der deinem Betriebssystem entspricht. 

Falls du dich auf R einlassen willst, dann empfehlen wir, auf deinem Rechner R und R-Studio zu installieren (https://posit.co/download/rstudio-desktop/) und dann den Beispielen hier zu folgen: https://github.com/KorAP/RKorAPClient

## Linux:
Zuerst wird R installiert. Führe dazu je nach Distribution, die du benutzt folgenden Befehl aus: 

#### Debian / Ubuntu:
```
sudo apt-get install -y r-base r-base-dev r-cran-tidyverse r-cran-r.utils r-cran-pixmap r-cran-webshot r-cran-ade4 r-cran-segmented r-cran-purrr r-cran-dygraphs r-cran-cvst r-cran-quantmod r-cran-graphlayouts r-cran-rappdirs r-cran-ggdendro r-cran-seqinr r-cran-heatmaply r-cran-igraph r-cran-plotly libcurl4-gnutls-dev libssl-dev libfontconfig1-dev libsecret-1-dev libxml2-dev libsodium-dev python3-pip python3-rpy2 python3-pandas
```
#### Fedora / CentOS / RHEL:
``` 
sudo yum install -y R R-devel libcurl-devel openssl-devel libxml2-devel libsodium-devel python3-pandas
```

Dieser Schritt kann eine Weile dauern, da viele verschiedene Pakete heruntergeladen werden. Sobald die Installation abgeschlossen ist, kannst du folgenden Befehl eingeben:

```
Rscript -e "install.packages('RKorAPClient', repos='https://cloud.r-project.org/')"
```

Falls dieser Installationsschritt mit angegebenem Befehl nicht funktioniert, setze ein ```sudo``` vor den Befehl und führe ihn erneut aus. 

Sobald diese Installation abgeschlossen ist, installiere den Client, um mit Python auf das DeReKo zugreifen zu können: 

```
python3 -m pip install KorAPClient
```

Die Installation sollte nun abgeschlossen sein und du solltest den Beispielcode «beispiel_korap.py» testen können!

## Windows: 

Lade zuerst von dieser Webseite das R-Paket herunter (momentane Version 4.2.3, Stand: 05.05.2022). 

Windows R-Installation: https://cran.r-project.org/bin/windows/base/

Sobald die exe-Datei heruntergeladen wurde, kannst du sie ausführen.  Bei den Einstellungen musst du keine Änderungen vornehmen. 
Öffne nun die Kommandozeile als Administrator. Das geht folgendermassen: 

<img src="screenshots/CmdAlsAdmin.JPG">

Setze nun in der Kommandozeile die folgenden Pfadvariablen (einfach eine Zeile nach der anderen eingeben und Enter drücken). 
Passe dabei bei der ersten Variablen den Pfad an, falls R bei dir unter einem anderen Pfad installiert wurde und falls du eine andere Version von R als 4.1.3 heruntergeladen hast. Tue das gleiche auch bei der dritten Pfadvariablen.

```
set R_HOME="C:\Program Files\R\R-4.1.3"
set R_USER=%R_HOME%
set path="C:\Program Files\R\R-4.1.3\bin";"C:\Program Files\R\R-4.1.3\bin\x64";%path%
```

Gib nun folgenden Befehl ein:

```
Rscript -e "install.packages('RKorAPClient', repos='https://cloud.r-project.org/')"
```

Sobald diese Installation abgeschlossen ist, installiere den Client, um mit Python auf das DeReKo zugreifen zu können: 

```
py -m pip install KorAPClient
```

Wenn dies nicht funktioniert, du bei der Installation viele rote Fehlermeldungen bekommst, dann kann dies womöglich an der fehlgeschlagenen Installation von ```rpy2``` (eine Schnittstelle zwischen R und Python) liegen. Probiere in diesem Fall, ```rpy2``` einzeln mit folgendem Befehl zu installieren: 

```
pip install rpy2
```
Probiere dann nochmal die obige KorAPClient- Installation. 

Die Installation sollte nun abgeschlossen sein und du solltest den Beispielcode «beispiel_korap.py» testen können!

## Mac: 

Lade zuerst von dieser Webseite das R-Paket herunter (momentane Version: 4.2.0, Stand: 05.05.2022). 

Mac R-Installation: https://cran.r-project.org/bin/macos/ 

Sobald die pkg-Datei heruntergeladen wurde, kannst du sie ausführen. Bei den Einstellungen musst du keine Änderungen vornehmen. 

Gib nun in der Kommandozeile folgenden Befehl ein: 

```
Rscript -e "install.packages('RKorAPClient', repos='https://cloud.r-project.org/')"
```

Sobald diese Installation abgeschlossen ist, installiere den Client, um mit Python auf das DeReKo zugreifen zu können: 

```
python3 -m pip install KorAPClient
```
Die Installation sollte nun abgeschlossen sein und du solltest den Beispielcode «beispiel_korap.py» testen können!

## Weitere Ressourcen: 

Falls die Installation nicht klappt, findest du hier auch noch Anleitungsvideos, denen du folgen kannst (leider nicht für Windows):  https://github.com/KorAP/RKorAPClient#full-installation-videos


Weitere Infos zur Nutzung des Clients gibt es auch hier: https://korap.github.io/PythonKorAPClient/doc/KorAPClient/ 

#### Achtung! 
Manchmal treten beim DeReKo Serverprobleme auf. Dann klappt die Abfrage nicht. Das liegt jedoch nicht an der Installation oder an deinem Skript. Warte in diesem Fall eine Weile und versuche es dann nochmal mit der Abfrage.
